/*
 * Copyright (c) 2019.
 * Autor: Beatriz Domínguez Callero
 * Esta obra está sujeta a una licencia de ReconocimientoNoComercial-SinObraDerivada 3.0 España de Creative Commons:
 * https://creativecommons.org/licenses/by-nc-nd/3.0/es/
 */

package com.beatriz.gestionaparcamiento.controller.utils;

import android.app.Activity;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

//Clase que contiene algunos métodos que se usan en diferentes sitios d ela app:
//Comprobación de emails, gestión de fechas, etcétera.
public class Utils  extends Activity {
    public static boolean isEmailValid(String email) {
        String expression = "^[\\w\\.-]+@([\\w\\-]+\\.)+[A-Z]{2,4}$";
        Pattern pattern = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(email);
        return matcher.matches();
    }

    public static Date getDateToday(){
        Date date =  Calendar.getInstance().getTime();
        return date;
    }


    public static String calendarToBBDDdate(Date date){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        return sdf.format(date.getTime());
    }

    public static String calendarToUIdate(Date date){
        SimpleDateFormat sdf = new SimpleDateFormat("dd / MM / YYYY");
        return sdf.format(date.getTime());
    }

    public static Date createDate(int year, int month, int day){
        GregorianCalendar calendar =  new GregorianCalendar( year, month, day );
        return calendar.getTime();
    }
}
