/*
 * Copyright (c) 2019.
 * Autor: Beatriz Domínguez Callero
 * Esta obra está sujeta a una licencia de ReconocimientoNoComercial-SinObraDerivada 3.0 España de Creative Commons:
 * https://creativecommons.org/licenses/by-nc-nd/3.0/es/
 */

package com.beatriz.gestionaparcamiento.model.preferences;

import android.content.Context;
import android.content.SharedPreferences;

import com.beatriz.gestionaparcamiento.model.objects.Parking;
import com.beatriz.gestionaparcamiento.model.objects.User;
import com.google.gson.Gson;

//Clase que gestiona las preferencias
//Patrón sigleton, para que todas accedan a una instancia
public class SharedPreference  {

    private SharedPreferences prefs;
    private static SharedPreference mInstance = null;
    private Gson gson;
    private Context context;

    final private String PREFERENCE_NAME = "GESTION_PARKING";
    //Preferencia del usuario
    final private String PREFERENCE_USER = "USER";
    //Preferencia del parking
    final private String PREFERENCE_PARKING = "PARKING";

    private SharedPreference(Context context){
        this.context=context;
        this.prefs = context.getSharedPreferences(PREFERENCE_NAME,context.MODE_PRIVATE);
        this.gson = new Gson();
    }
    public static SharedPreference getInstance(Context context) {
        if (mInstance == null) {
            mInstance = new SharedPreference(context);
        }
        return mInstance;
    }

    public User getUserPreferences(){
        String user_pref = prefs.getString(PREFERENCE_USER, null);
        if(user_pref!=null){
            User user = gson.fromJson(user_pref, User.class);
            return user;
        }
        return null;
    }
    public void setUserPreferences(User user){
        SharedPreferences.Editor editor = prefs.edit();
        String json = gson.toJson(user);
        editor.putString(PREFERENCE_USER, json);
        editor.commit();
    }
    public Parking getParkingPreferences(){
        String user_pref = prefs.getString(PREFERENCE_PARKING, null);
        if(user_pref!=null){
            Parking parking = gson.fromJson(user_pref, Parking.class);
            return parking;
        }
        return null;
    }
    public void setParkingPreferences(Parking user){
        SharedPreferences.Editor editor = prefs.edit();
        String json = gson.toJson(user);
        editor.putString(PREFERENCE_PARKING, json);
        editor.commit();
    }
}
